<script lang="ts">
import Vue from 'vue';
import { SolutionsVideoModal } from '../solutions/index.vue';
import { Badge, Carousel } from '../common/index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  components: {
    Badge,
    Carousel,
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      images: this.data.images,
      modal: {
        open: false,
      },
    };
  },
  methods: {
    handleClick(buttonData: any) {
      if (buttonData.modal) {
        this.modal.open = true;
        // Make sure Vimeo analytics work:
        // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
        setTimeout(() => {
          window.__vimeoRefresh();
        }, 3000);
      }
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="hero-wrapper">
    <SlpContainer>
      <section class="homepage-hero">
        <SlpRow>
          <SlpColumn :cols="5" class="slp-flex slp-align-items-center">
            <div class="homepage-hero__title-column">
              <Badge v-if="data.badge" :badge="data.badge" />
              <SlpTypography tag="h1" variant="heading2-bold" class="title">{{
                data.title
              }}</SlpTypography>

              <SlpTypography tag="h2" variant="body1" class="subtitle">
                <span v-html="data.subtitle"></span>
              </SlpTypography>
              <div class="slp-mb-16 slp-mt-24">
                <SlpButton
                  class=""
                  variant="primary"
                  :data-ga-name="data.primaryButton.data_ga_name"
                  :data-ga-location="data.primaryButton.data_ga_location"
                  :href="data.primaryButton.link"
                  @click.native="handleClick(data.primaryButton)"
                  >{{ data.primaryButton.text }}
                </SlpButton>
                <SlpButton
                  variant="tertiary"
                  class="homepage-hero__secondary-button"
                  :href="data.secondary_button.link"
                  :data-ga-name="data.secondary_button.data_ga_name"
                  :data-ga-location="data.secondary_button.data_ga_location"
                  @click.native="handleClick(data.secondary_button)"
                  >{{ data.secondary_button.text }}
                  <nuxt-img
                    src="/nuxt-images/icons/play-circle.svg"
                    alt=""
                    loading="lazy"
                    format="webp"
                    quality="99"
                  />
                </SlpButton>
              </div>
            </div>
          </SlpColumn>
          <SlpColumn
            :cols="7"
            size="md"
            class="homepage-hero__media-column slp-flex slp-align-items-center"
          >
            <Carousel
              :images="images"
              :actions="false"
              :auto-slide-interval="4000"
              :show-progress-bar="true"
              :image-copy="data.image_copy"
              :indicator-navigation="true"
            ></Carousel>
          </SlpColumn>
        </SlpRow>
        <SolutionsVideoModal
          v-show="modal.open"
          light-background
          :visible="modal.open"
          @close="closeModal"
        >
          <template #body>
            <lite-vimeo
              :videoid="
                getVimeoVideoId(
                  createVideoSource(data.secondary_button.modal.video_link),
                )
              "
              :videotitle="
                data.secondary_button?.modal?.video_title ?? 'Video player'
              "
              autoplay
            ></lite-vimeo>
          </template>
        </SolutionsVideoModal>
      </section>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.hero-wrapper {
  background-position: 80% center;
  background-size: cover;
  background-image: url('/nuxt-images/home/hero/gradient-mobile.jpg');
  @media (min-width: $breakpoint-md) {
    background-image: url('/nuxt-images/home/hero/gradient-desktop.jpg');
  }
}
.homepage-hero {
  margin-bottom: $spacing-48;
  margin-top: $spacing-96;
  position: relative;

  @media (min-width: $breakpoint-lg) {
    margin-top: $spacing-48;
    padding-bottom: $spacing-64;
  }

  .subtitle {
    margin-top: $spacing-8;
    margin-bottom: $spacing-24;

    @media (min-width: $breakpoint-lg) {
      margin-top: $spacing-16;
      margin-right: $spacing-64;
    }
  }

  .slp-btn svg,
  .slp-btn img {
    vertical-align: inherit;
    margin-left: $spacing-8;
    transition: all 0.2s ease-in-out;
  }

  .slp-btn:hover img {
    transform: translateX($spacing-8);
  }
  .slp-col-md-7,
  .slp-col-lg-7 {
    position: inherit;
  }

  &__media-column {
    margin: 0 auto;
    height: 100%;
    width: 100%;

    @media (min-width: $breakpoint-lg) {
      height: unset;
      width: unset;
    }
  }

  &__secondary-button {
    padding-left: 11px;
  }

  @media (max-width: $breakpoint-md) {
    text-align: left;

    h5 {
      margin-right: 0;
    }

    .slp-btn {
      width: 100%;
      justify-content: center;
    }

    &__title-column {
      margin-right: 0;
      margin-bottom: $spacing-24;
    }
  }
  @media (max-width: $breakpoint-lg) {
    .slp-btn {
      margin-bottom: $spacing-8;
      &:last-child {
        margin: 0;
      }
    }
  }
}

@media (max-width: $breakpoint-md) {
  .progressbar-container,
  .homepage-hero__media-column {
    display: none;
  }
}
</style>
